import urllib2, re, sys, os, time
from htmlentitydefs import name2codepoint as n2cp

if hasattr(sys, "frozen"):
	DIR = os.path.dirname(sys.executable)
else:
	DIR = os.path.dirname(__file__)


def substitute_entity(match):
	ent = match.group(3)
	
	if match.group(1) == "#":
		if match.group(2) == '':
			return unichr(int(ent))
		elif match.group(2) == 'x':
			return unichr(int('0x'+ent, 16))
	else:
		cp = n2cp.get(ent)

		if cp:
			return unichr(cp)
		else:
			return match.group()

def HTMLDecode(string):
	entity_re = re.compile(r'&(#?)(x?)(\d{1,5}|\w{1,8});')
	return entity_re.subn(substitute_entity, string)[0]




if len(sys.argv) < 2:
	print '%ERROR%No USGN ID specified'
	sys.exit()
else:
	UID = sys.argv[1]

try:
	req = urllib2.urlopen("http://unrealsoftware.de/profile.php?userid=" + UID)
	page = req.read()
	if page.find('<div class="fa" style="top:5px; color:#FFF;">') == -1:
		print("%ERROR%This user does not exist")
		
	else:
		start = page.find("<h1>")
		end = page.find("<", start + 4)
		
		name = HTMLDecode(page[start+4:end].strip())

		print(name)
		
		if sys.argv[2] == "SAVE":
			try:
				f = open(DIR + "\\USGNNames\\" + UID, "w")
				f.write(str(int(time.time())) + name)
				f.close()
			except:
				print("%ERROR%could not open save file")

except Exception, e:
	if hasattr(e, 'reason'):
		print("%ERROR%" + str(e.reason))
	elif hasattr(e, 'code'):
		print("%ERROR%" + str(e.code))
