from distutils.core import setup
import py2exe
import sys

if len(sys.argv) == 1:
    sys.argv.append("py2exe")
    sys.argv.append("-q")

class Target:
	def __init__(self, **kw):
		self.__dict__.update(kw)
		self.version = "1"
		self.company_name = "CS2DWorld"
		self.copyright = "Copyright 2011 by www.cs2d.nl"
		self.name = "GetUSGNName Console"
		self.author = 'Banaan'


excludes = ['_ssl', 'doctest', 'pdb', 'unittest', 'difflib', 'inspect', 'pyreadline', 'pickle', \
'optparse', 'gettext', 'getopt', 'calendar', 'locale', 'textwrap', 'weakref', 'logging', '_ctypes', \
'time', 'sll', 'stringprep','_gtkagg', '_tkagg', 'bsddb', 'curses', 'email', 'pywin', 'pywin.debugger', \
'pywin.debugger.dbgcon', 'pywin.dialogs', 'pywin.dialogs.list', 'Tkconstants', 'Tkinter', 'tcl', \
"_imagingtk", "PIL._imagingtk", "ImageTk", "PIL.ImageTk", "FixTk", 'threading', 'OpenGL', 'win32com', \
'logging', 'SimpleHTTPServer', 'SocketServer', '_LWPCookieJar','_MozillaCookieJar', '_threading_local', \
'_scproxy', 'email.utils', 'htmllib', 'SimpleXMLRPCServer', 'site', 'smtpd', 'smtplib', 'sndhdr', 'Cookie', \
'cookielib', 'ftplib', 'mimetypes', 'subprocess', 'ssl', 'StringIO', 'quopri', 'traceback', 'uu', 'repr', \
'os2emxpath', 'getpass', 'fnmatch', 'dummy_thread', 'atexit', 'select' ]

cg = Target(
    description = "Console app to fetch Unreal Software name",
    script = "GetUSGNName.pyw",
    dest_base = "GetUSGNName")

setup(
    options = {"py2exe": {"compressed": 1,
                          "optimize": 2,
						  "bundle_files": 1,
						  "ascii": True,
						  "dll_excludes": ['msvcr71.dll', 'oci.dll', 'libgdk-win32-2.0-0.dll','libgobject-2.0-0.dll','libgdk_pixbuf-2.0-0.dll','wxmsw26uh_vc.dll','tk83.dll','tcl83.dll'],
                          "excludes": excludes}},
    zipfile = None,
    console = [cg],
    )
